if Config.useNewQBExport then
    QBCore = exports['qb-core']:GetCoreObject()
end

--
-- Diving Gear
--
QBCore.Functions.CreateUseableItem('kuz_divinggear', function(source)
    TriggerClientEvent('kuz_diving:applyGear', source, 0)
end)

QBCore.Functions.CreateUseableItem('kuz_divinggeargood', function(source)
    TriggerClientEvent('kuz_diving:applyGear', source, 1)
end)

RegisterServerEvent("kuz_diving:sell")
AddEventHandler("kuz_diving:sell", function(seller)
    local _source = source
    local Player = QBCore.Functions.GetPlayer(_source)

    local soldAnything = false
    for k, item in pairs(Config.sellLocations[seller].items) do
        local inventoryItem = Player.Functions.GetItemByName(item.item)
        if Player.PlayerData.items and inventoryItem ~= nil then
            if inventoryItem.amount > 0 then
                soldAnything = true
                Player.Functions.RemoveItem(item.item, inventoryItem.amount)
                Player.Functions.AddMoney(Config.sellLocations[seller].useAccount, item.price * inventoryItem.amount)
                TriggerClientEvent('QBCore:Notify', source, 'You have sold: ' .. inventoryItem.amount .. 'x ' .. item.label .. '\n for $' .. item.price * inventoryItem.amount, 'success')
            end
        end
    end

    if not soldAnything then
        TriggerClientEvent('QBCore:Notify', source, 'You don\'t have any items to sell here', 'error')
    end
end)


QBCore.Functions.CreateCallback('kuz_diving:hasItem', function(source, cb, item)
    local _source = source
    local Player = QBCore.Functions.GetPlayer(_source)
    if Player.Functions.GetItemByName(item) then
        cb(true)
    else
        cb(false)
    end
end)

RegisterServerEvent("kuz_diving:getLoot")
AddEventHandler("kuz_diving:getLoot", function(playerCoords)
    local _source = source
    local Player = QBCore.Functions.GetPlayer(_source)

    local nearestDistance = 9999.0
    local nearestId

    for k in pairs(Config.lootLocations) do
        local lootLoc = Config.lootLocations[k]
        local dist = GetDistanceBetweenCoords(playerCoords.x, playerCoords.y, playerCoords.z, lootLoc.x, lootLoc.y, lootLoc.z)
        if dist < nearestDistance or nearestDistance == nil then
            nearestDistance = dist
            nearestId = k
        end
    end
    if nearestDistance > Config.lootLocations[nearestId].radius + 20.0 then
        return
    end

    local lootLoc = Config.lootLocations[nearestId]

    local selectedItem

    local hit = math.random(0, 100)
    local value = 0
    for k in pairs(lootLoc.loot) do
        local item = lootLoc.loot[k]
        value = value + item.chance
        if value >= hit then
            selectedItem = item
            break
        end
    end

    if selectedItem ~= nil then
        local amount = math.random(selectedItem.amount_min, selectedItem.amount_max)
        if Player.Functions.AddItem(selectedItem.item, amount) then
            sendFoundNotification(_source, selectedItem.item, amount)
        else
            if amount > 1 then
                if Player.Functions.AddItem(selectedItem.item, 1) then
                    sendFoundNotification(_source, selectedItem.item, 1)
                    return
                end
            end
            TriggerClientEvent('QBCore:Notify', source, 'You can\'t hold more loot', 'error')
        end
    else
        TriggerClientEvent('QBCore:Notify', source, 'You found nothing of interest', 'error')
    end
end)

--
-- Helpers
--
function sendFoundNotification(source, item, amount)
    local _source = source
    local Player = QBCore.Functions.GetPlayer(_source)

    if amount > 1 then
        TriggerClientEvent('QBCore:Notify', source, 'You found x' .. amount .. ' ' .. QBCore.Shared.Items[item].label)
    else
        TriggerClientEvent('QBCore:Notify', source, 'You found a ' .. QBCore.Shared.Items[item].label)
    end

end

function GetDistanceBetweenCoords(x, y, z, x2, y2, z2)
    return ((x2 - x)^2 + (y2 - y)^2 + (z2 - z)^2)^0.5
end